/*******************************************************************************
Copyright (c) 2022, Jan Koester jan.koester@gmx.net
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
	* Redistributions of source code must retain the above copyright
	  notice, this list of conditions and the following disclaimer.
	* Redistributions in binary form must reproduce the above copyright
	  notice, this list of conditions and the following disclaimer in the
	  documentation and/or other materials provided with the distribution.
	* Neither the name of the <organization> nor the
	  names of its contributors may be used to endorse or promote products
	  derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/


// sys::so::Elf::Elf() {
//
// }
//
// sys::so::Elf::~Elf() {
//
// }
//
// sys::so::Elf_X86_64::Elf_X86_64() {
//
// }
//
// sys::so::Elf_X86_64::~Elf_X86_64() {
//
// }
//
// void sys::so::Elf_X86_64::load(const char* path) {
// 	sys::SystemException excep;
// 	sys::file elffile(path, sys::filestat::rdonly);
// 	unsigned char* buf;
// 	size_t elfsize = elffile.getsize();
// 	size_t curread = 0;
// 	buf = new unsigned char[elfsize];
// 	do {
// 		int rstat = elffile.read(buf + curread, 255);
// 		switch (rstat) {
// 		case -1:
// 			delete buf;
// 			excep[SystemException::Error] << "Read Elf File goes wrong!";
// 				throw excep;
// 		case  0:
// 			curread += 255;
// 			break;
// 		default:
// 			curread += rstat;
// 			break;
// 		}
// 	} while (curread < elfsize);
//
// 	if (buf[EI_MAG0] != ELFMAG0 || buf[EI_MAG1] != ELFMAG1 || buf[EI_MAG2] != ELFMAG2 || buf[EI_MAG3] != ELFMAG3){
// 		excep[SystemException::Error] << "Read Elf File wrong main header!";
// 		throw excep;
// 	}
//
// 	memcpy(_Header.e_ident,buf,16);
//
// 	if (buf[4] != ELFCLASS64) {
// 		excep[SystemException::Error] << "Read Elf File wrong class header!";
// 		throw excep;
// 		_Header.e_type = ELFCLASS64;
// 	}
// }
//
// void sys::so::Elf_X86_64::unload() {
//
// }
//
// void sys::so::parseElf(const char* path, sys::so::Elf** elf, void** dl) {
// 	sys::SystemException excep;
// 	sys::file elffile(path, sys::filestat::rdonly);
// 	unsigned char* buf;
// 	size_t curread = 0;
// 	buf = new unsigned char[15];
// 	do {
// 		int rstat = elffile.read(buf + curread, 15);
// 		switch (rstat) {
// 		case -1:
// 			delete buf;
// 			excep[sys::SystemException::Error] << "Read Elf File goes wrong!";
// 			throw excep;
// 		case  0:
// 			curread += 15;
// 			break;
// 		default:
// 			curread += rstat;
// 			break;
// 		}
// 	} while (curread < 15);
//
// 	if (buf[EI_OSABI] != ELFOSABI_LINUX) {
// 		excep[sys::SystemException::Error] << "Read Elf only Linux at the moment supported";
// 		throw excep;
// 	}
//
// 	if (buf[EI_CLASS] == ELFCLASS64) {
// 		*elf = new sys::so::Elf_X86_64();
// 	}
//
// 	delete[] buf;
//
// 	(*elf)->load(path);
//
//
// }
