#pragma once


#include <stdint.h>

#include <bits/sysbits.h>
#include <bits/syscall.h>

#define F_GETFD     1   /* get close_on_exec */
#define F_SETFD     2   /* set/clear close_on_exec */
#define F_GETFL     3   /* get file->f_flags */
#define F_SETFL     4   /* set file->f_flags */

namespace sys {
    
    template<class TO,class TMODE>
    TO TOpen(const char *pathname,int flags,TMODE tmode){
        if(tmode<0)
            return -1;
        return syscall3(__NR_open,(unsigned long)pathname,flags,(unsigned long)tmode);
    }
    
    template<class TOA,class TMODE>
    TOA TOpenAt(int dirfd,const char *pathname,int flags,TMODE tmode){
        if(tmode<0)
            return -1;
        return syscall4(__NR_openat,dirfd,(unsigned long)pathname,flags,(unsigned long)tmode);
    }
    
    template<class TC>
    TC TClose(int fd){
        return syscall1(__NR_close,fd);
    }
    
    template<class TR,class TRT>
    TR TRead(int fd,TRT buf,size_t size){
        return syscall3(__NR_read,fd,(unsigned long)buf,(long)size);
    }
    
    template<class TW,class TWT>
    TW TWrite(int fd,TWT buf,size_t size){
        return syscall3(__NR_write,fd,(unsigned long)buf,size);
    }
    
};
