/*******************************************************************************
Copyright (c) 2022, Jan Koester jan.koester@gmx.net
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of the <organization> nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/

#include <bits/alltypes.h>

#pragma once

#define CSIGNAL		         0x000000ff	/* signal mask to be sent at exit */
#define CLONE_VM	         0x00000100	/* set if VM shared between processes */
#define CLONE_FS	         0x00000200	/* set if fs info shared between processes */
#define CLONE_FILES	         0x00000400	/* set if open files shared between processes */
#define CLONE_SIGHAND        0x00000800	/* set if signal handlers shared */
#define CLONE_PID	         0x00001000	/* set if pid shared */
#define CLONE_SETTLS         0x00080000 /* create a new TLS for the child */
#define CLONE_THREAD         0x00010000 /* Same thread group? */
#define CLONE_SYSVSEM        0x00040000 /* share system V SEM_UNDO semantics */
#define CLONE_PARENT_SETTID  0x00100000 /* set the TID in the parent */
#define CLONE_CHILD_CLEARTID 0x00200000 /* clear the TID in the child */

#ifdef __cplusplus
extern "C" {
#endif

    int sched_yield(void);

    typedef struct cpu_set_t {
        unsigned long __bits[128/sizeof(long)];
    } cpu_set_t;

    int __sched_cpucount (size_t setsize, const cpu_set_t *setp);

#ifdef __cplusplus
};
#endif
