#include <string.h>
#include <stdlib.h>

template<class T,class A>
T tldiv(A num,A den){
    return (T){ num/den, num%den };
}


extern "C" {
    
    div_t div(int num, int den){
        return tldiv<div_t,int>(num,den);
    }
    
    ldiv_t ldiv(long num, long den){
        return tldiv<ldiv_t,long>(num,den); 
    }
    
    lldiv_t lldiv(long long num, long long den){
        return tldiv<lldiv_t,long long>(num,den); 
    }
       
    void reverse(char s[]){
        int i, j;
        char c;
    
        for (i = 0, j = strlen(s)-1; i<j; i++, j--) {
            c = s[i];
            s[i] = s[j];
            s[j] = c;
        }
    }    
    
    void itoa(int n, char s[]){
        int i, sign;
        if ((sign = n) < 0)
            n = -n;
        i = 0;
        do {       /* generate digits in reverse order */
            s[i++] = n % 10 + '0';   /* get next digit */
        } while ((n /= 10) > 0);     /* delete it */
        if (sign < 0)
            s[i++] = '-';
        s[i] = '\0';
        reverse(s);
    }

    void ltoa(long n, char s[]){
        long i, sign;
        if ((sign = n) < 0)
            n = -n;
        i = 0;
        do {       /* generate digits in reverse order */
            s[i++] = n % 10 + '0';   /* get next digit */
        } while ((n /= 10) > 0);     /* delete it */
        if (sign < 0)
            s[i++] = '-';
        s[i] = '\0';
        reverse(s);
    }
    
    void ultoa(unsigned long n, char s[]){
        unsigned int i;
        i = 0;
        do {       /* generate digits in reverse order */
            s[i++] = n % 10 + '0';   /* get next digit */
        } while ((n /= 10) > 0);     /* delete it */
        s[i] = '\0';
        reverse(s);
    }
    
    int atoi (const char* nptr){
        int sign = 1, base = 0, i = 0;
        while (nptr[i] == ' '){
            i++;
        }
        if (nptr[i] == '-' || nptr[i] == '+'){
            sign = 1 - 2 * (nptr[i++] == '-');
        }
        while (nptr[i] >= '0' && nptr[i] <= '9'){
            if (base > +2147483647 / 10
                || (base == +2147483647 / 10
                && nptr[i] - '0' > 7)){
                if (sign == 1)
                    return +2147483647;
                else
                    return -2147483648;
                }
                base = 10 * base + (nptr[i++] - '0');
        }
        return base * sign;
    }
    
    long long atoll(const char* nptr){
        long sign = 1, base = 0, i = 0;
        while (nptr[i] == ' '){
            i++;
        }
        if (nptr[i] == '-' || nptr[i] == '+'){
            sign = 1 - 2 * (nptr[i++] == '-');
        }
        while (nptr[i] >= '0' && nptr[i] <= '9'){
            if (base > +9223372036854775807 / 10
                || (base == +9223372036854775807 / 10
                && nptr[i] - '0' > 7)){
                if (sign == 1)
                    return +9223372036854775807;
                else
                    return -9223372036854775807;
                }
                base = 10 * base + (nptr[i++] - '0');
        }
        return base * sign;    
    }
    
    unsigned long atoul(char* str){
        unsigned long sign = 1, base = 0, i = 0;
        while (str[i] == ' '){
            i++;
        }
        while (str[i] >= '0' && str[i] <= '9'){
            if (base > +4294967295 / 10
                || (base == +4294967295 / 10
                && str[i] - '0' > 7)){
                if (sign == 1)
                    return +4294967295;
                }
                base = 10 * base + (str[i++] - '0');
        }
        return base * sign;
    }
    
    void ftoa(float n, char s[]){

    }
    
    void* calloc (size_t num, size_t size){
        return operator new(num*size);
    }
    
    void* malloc (size_t size){
        return operator new(size);
    }
    
    void free (void* ptr){
        operator delete(ptr);
    }
    
    void* realloc (void* ptr, size_t size){
        char *dest = (char*)operator new(size);

        size_t i=0;
        while(i<size){
            dest[i]=((char*)ptr)[i];
        }
        operator delete(ptr);
        return (void*) dest;
    }
    
    /*needs to implemented*/
    int abs (int n){
        return 0;
    }
    
    int at_quick_exit (void (*func)(void)){
        return 0;
    }
    
    double atof (const char* str){
        return 0;
    }
//     
    long int atol ( const char * str ){
        return 0;
    }
    
    void* bsearch (const void* key, const void* base,
               size_t num, size_t size,
               int (*compar)(const void*,const void*)){
        return nullptr;
    }
    
    int mblen (const char* pmb, size_t max){
        return 0;
    }
    
    size_t mbstowcs (wchar_t* dest, const char* src, size_t max){
        return 0;
    }
    
    int mbtowc (wchar_t* pwc, const char* pmb, size_t max){
        return 0;
    }
    
    void qsort (void* base, size_t num, size_t size,
            int (*compar)(const void*,const void*)){
        
    }
    
    int rand (void){
        return 0;
    }
    
    void srand (unsigned int seed){
        
    }
    
    double strtod (const char* str, char** endptr){
        return 0;
    }
    
    long double strtold (const char* str, char** endptr){
        return 0;
    }
    
    long int strtol (const char* str, char** endptr, int base){
        return 0;
    }
    
    long long int strtoll (const char* str, char** endptr, int base){
        return 0;
    }
    
    unsigned long int strtoul (const char* str, char** endptr, int base){
        return 0;
    }
    
    unsigned long long int strtoull (const char* str, char** endptr, int base){
        return 0;
    }
    
    float strtof (const char* str, char** endptr){
        return 0;
    }
    
    int system (const char* command){
       return 0; 
    }
    
    char* getenv (const char* name){
        return nullptr;
    };
    
    size_t wcstombs (char* dest, const wchar_t* src, size_t max){
        return 0;
    }
    
    int wctomb (char* pmb, wchar_t wc){
        return 0;
    }
    
    long int labs (long int n){
        return 0;
    }
    
    long long int llabs (long long int n){
        return 0;
    }
};
